## glibc-2.0.6.tar.gz

=== Makefile ===
# Copyright (C) 1991, 92, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

#
#	Master Makefile for the GNU C library
#
ifneq (,)
This makefile requires GNU Make.
endif


# This is the default target; it makes everything except the tests.
.PHONY: all
all: lib others

define autoconf-it
@-rm -f $@.new
autoconf $(ACFLAGS) $< > $@.new
chmod a-w,a+x $@.new
mv -f $@.new $@
test ! -d CVS || cvs commit -m'Regenerated: autoconf $(ACFLAGS) $<' $@
endef

configure: configure.in aclocal.m4; $(autoconf-it)
%/configure: %/configure.in aclocal.m4; $(autoconf-it)

include Makeconfig

ifndef avoid-generated
-include $(objpfx)sysd-dirs
define \n


endef
sysdep-subdirs := $(subst $(\n), ,$(sysdep-subdirs))
endif

# These are the subdirectories containing the library source.
subdirs = csu assert ctype db locale intl catgets math setjmp signal stdlib \
	  stdio-common $(stdio) malloc string wcsmbs time dirent grp pwd \
	  posix io termios resource misc login socket sysvipc gmon gnulib \
	  wctype manual shadow md5-crypt nss $(sysdep-subdirs) po debian \
	  $(add-ons) elf
export subdirs := $(subdirs)	# Benign, useless in GNU make before 3.63.

# The mach and hurd subdirectories have many generated header files which
# much of the rest of the library depends on, so it is best to build them
# first (and mach before hurd, at that).  The before-compile additions in
# sysdeps/{mach,hurd}/Makefile should make it reliably work for these files
# not to exist when making in other directories, but it will be slower that
# way with more somewhat expensive `make' invocations.
subdirs	:= $(filter mach,$(subdirs)) $(filter hurd,$(subdirs)) \
	   $(filter-out mach hurd,$(subdirs))

# All initialization source files.
+subdir_inits	:= $(wildcard $(foreach dir,$(subdirs),$(dir)/init-$(dir).c))
# All subdirectories containing initialization source files.
+init_subdirs	:= $(patsubst %/,%,$(dir $(+subdir_inits)))


# These are the targets that are made by making them in each subdirectory.
+subdir_targets	:= subdir_lib objects objs others subdir_mostlyclean	\
		   subdir_clean subdir_distclean subdir_realclean	\
		   tests subdir_lint.out				\
		   subdir_distinfo					\
		   subdir_echo-headers subdir_echo-distinfo		\
		   subdir_install					\
		   $(addprefix install-, no-libc.a bin lib data headers others)

headers := errno.h sys/errno.h errnos.h limits.h values.h	\
	   features.h gnu-versions.h libc-lock.h xopen_lim.h
aux	 = sysdep $(libc-init) version
before-compile += $(objpfx)version-info.h

echo-headers: subdir_echo-headers

# What to install.
install-others = $(inst_includedir)/gnu/stubs.h
install-bin = glibcbug

ifeq (yes,$(build-shared))
install-others += $(inst_includedir)/gnu/lib-names.h
endif

ifeq (yes,$(gnu-ld))
libc-init = set-init
else
libc-init = munch-init
$(objpfx)munch-init.c: munch.awk munch-tmpl.c $(+subdir_inits)
	awk -f $< subdirs='$(+init_subdirs)' $(word 2,$^) > $@-t
	mv -f $@-t $@
generated := $(generated) munch-init.c
endif


include Makerules

# Install from subdirectories too.
install: subdir_install

# Create linkfs for shared libraries using the `ldconfig' program is possible.
# Ignore the error if we cannot update /etc/ld.so.cache.
ifeq (no,$(cross-compiling))
ifeq (yes,$(build-shared))
install:
	-test ! -x $(common-objpfx)elf/ldconfig || \
	  $(common-objpfx)elf/ldconfig -d $(inst_slibdir) $(inst_libdir)
endif
endif

# Build subdirectory lib objects.
lib-noranlib: subdir_lib

ifeq (yes,$(build-shared))
# Build the shared object from the PIC object library.
lib: $(common-objpfx)libc.so
endif

all-Subdirs-files = $(wildcard $(addsuffix /Subdirs, $(config-sysdirs)))
$(objpfx)sysd-dirs: $(+sysdir_pfx)config.make $(all-Subdirs-files)
	(echo define sysdep-subdirs;				\
	 sed 's/#.*$$//' $(all-Subdirs-files) /dev/null;	\
	 echo endef) > $@-tmp
	mv -f $@-tmp $@

all-Banner-files = $(wildcard $(addsuffix /Banner, $(subdirs)))
$(objpfx)version-info.h: $(+sysdir_pfx)config.make $(all-Banner-files)
	(case $(config-os) in \
	   linux*) version=`(echo -e "#include <linux/version.h>\nUTS_RELEASE"\
			     | $(CC)  -E -P - | \
			     sed -e 's/"\([^"]*\)".*/\1/p' -e d) 2>/dev/null`;\
		   if [ -z "$$version" ]; then \
		     if [ -r /proc/version ]; then \
		       version=`sed 's/.*version \([^ ]*\) .*/>>\1<</' \
				< /proc/version`; \
		     else \
		       version=`uname -r`; \
		     fi; \
		   fi; \
		   echo -n "\"Compiled on a Linux $$version system "; \
		   echo "on `date +%Y/%m/%d`.\\n\"" ;; \
	   *) ;; \
	 esac; \
	 files="$(all-Banner-files)";				\
	 if test -n "$$files"; then				\
	   echo "\"Available extensions:";			\
	   sed -e '/^#/d' -e 's/^[[:space:]]*/	/' $$files;	\
	   echo "\"";						\
	 fi) > $@T
	mv -f $@T $@
generated += version-info.h

version.c-objects := $(addprefix $(objpfx)version,$(object-suffixes))
$(version.c-objects): $(objpfx)version-info.h

# Makerules creates a file `stub-$(subdir)' for each subdirectory, which
# contains `#define __stub_FUNCTION' for each function which is a stub.
# Here we paste all of these together into <gnu/stubs.h>.

subdir-stubs := $(foreach dir,$(subdirs),$(common-objpfx)stub-$(dir))

# Since stubs.h is never needed when building the library, we simplify the
# hairy installation process by producing it in place only as the last part
# of the top-level `make install'.  It depends on subdir_install, which
# iterates over all the subdirs; subdir_install in each subdir depends on
# the subdir's stubs file.  Having more direct dependencies would result in
# extra iterations over the list for subdirs and many recursive makes.
$(inst_includedir)/gnu/stubs.h: subdir_install
	@rm -f $(objpfx)stubs.h
	(echo '/* This file is automatically generated.';\
	 echo '   It defines a symbol `__stub_FUNCTION'\'' for each function';\
	 echo '   in the C library which is a stub, meaning it will fail';\
	 echo '   every time called, usually setting errno to ENOSYS.  */';\
	 sort $(subdir-stubs)) > $(objpfx)stubs.h
	if test -r $@ && cmp -s $(objpfx)stubs.h $@; \
	then echo 'stubs.h unchanged'; \
	else $(INSTALL_DATA) $(objpfx)stubs.h $@; fi
	rm -f $(objpfx)stubs.h

ifeq (yes,$(build-shared))

$(inst_includedir)/gnu/lib-names.h: $(common-objpfx)gnu/lib-names.h
	if test -r $@ && cmp -s $< $@; \
	then echo 'gnu/lib-names.h unchanged'; \
	else $(INSTALL_DATA) $< $@; fi
endif

# The `glibcbug' script contains the version number and it shall be rebuild
# whenever this changes or the `glibcbug.in' file.
$(objpfx)glibcbug: $(common-objpfx)config.status glibcbug.in
	cd $(<D); CONFIG_FILES=$(@F) CONFIG_HEADERS= $(SHELL) $(<F)

# This makes the Info or DVI file of the documentation from the Texinfo source.
.PHONY: info dvi
info dvi:
	$(MAKE) $(PARALLELMFLAGS) -C manual $@

# This makes all the subdirectory targets.

# For each target, make it depend on DIR/target for each subdirectory DIR.
$(+subdir_targets): %: $(addsuffix /%,$(subdirs))

# Compute a list of all those targets.
all-subdirs-targets := $(foreach dir,$(subdirs),\
				 $(addprefix $(dir)/,$(+subdir_targets)))

# The action for each of those is to cd into the directory and make the
# target there.
$(all-subdirs-targets):
	$(MAKE) $(PARALLELMFLAGS) -C $(@D) $(@F)

.PHONY: $(+subdir_targets) $(all-subdirs-targets)

# Targets to clean things up to various degrees.

.PHONY: clean realclean distclean distclean-1 parent-clean parent-mostlyclean

# Subroutines of all cleaning targets.
parent-mostlyclean: common-mostlyclean # common-mostlyclean is in Makerules.
	-rm -f $(foreach o,$(object-suffixes),\
		   $(common-objpfx)$(patsubst %,$(libtype$o),c)) \
	       $(addprefix $(objpfx),$(install-lib))
parent-clean: parent-mostlyclean common-clean
	-rm -f $(addprefix $(common-objpfx),$(common-generated))
	-rm -f $(addprefix $(objpfx),sysd-Makefile sysd-dirs sysd-rules)

clean: parent-clean
# This is done this way rather than having `subdir_clean' be a
# dependency of this target so that libc.a will be removed before the
# subdirectories are dealt with and so they won't try to remove object
# files from it when it's going to be removed anyway.
	@$(MAKE) subdir_clean no_deps=t
mostlyclean: parent-mostlyclean
	@$(MAKE) subdir_mostlyclean no_deps=t

# The realclean target is just like distclean for the parent, but we want
# the subdirs to know the difference in case they care.
realclean distclean: parent-clean
# This is done this way rather than having `subdir_distclean' be a
# dependency of this target so that libc.a will be removed before the
# subdirectories are dealt with and so they won't try to remove object
# files from it when it's going to be removed anyway.
	@$(MAKE) distclean-1 no_deps=t distclean-1=$@ avoid-generated=yes

# Subroutine of distclean and realclean.
distclean-1: subdir_$(distclean-1)
	-rm -f $(config-generated)
	-rm -f $(addprefix $(objpfx),config.status config.cache config.log)
	-rm -f $(addprefix $(objpfx),config.make config-name.h config.h)
ifdef objdir
	-rm -f $(objpfx)Makefile
endif
	-rm -f $(sysdep-$(distclean-1))

.PHONY: echo_subdirs
echo_subdirs:;@echo '$(subdirs)'

.PHONY: echo-distinfo parent_echo-distinfo
echo-distinfo: parent_echo-distinfo subdir_echo-distinfo
parent_echo-distinfo:
	@echo $(addprefix +header+,$(headers)) \
	      $(addprefix +nodist+,$(generated))


# Make the distribution tarfile.

distribute  := README INSTALL FAQ NOTES NEWS PROJECTS BUGS		\
	       COPYING.LIB COPYING ChangeLog ChangeLog.[0-9]		\
	       Makefile Makeconfig Makerules Rules Make-dist MakeTAGS	\
	       extra-lib.mk o-iterator.mk				\
	       ansidecl.h mkinstalldirs move-if-change install-sh	\
	       configure configure.in aclocal.m4 config.sub config.guess\
	       config.h.in config.make.in config-name.in Makefile.in	\
	       autolock.sh rellns-sh munch-tmpl.c munch.awk interp.c	\
	       sysdep.h set-hooks.h libc-symbols.h version.h shlib-versions \
	       rpm/Makefile rpm/template rpm/rpmrc nsswitch.h netgroup.h \
	       mcheck.h glibcbug.in

distribute := $(strip $(distribute))
generated := $(generated) stubs.h version-info.h

README: README.template version.h ; # Make-dist should update README.

define format-me
@rm -f $@
makeinfo --no-validate --no-warn --no-headers $< -o $@
-chmod a-w $@
endef
INSTALL: manual/maint.texi; $(format-me)
NOTES: manual/creature.texi; $(format-me)
manual/dir-add.texi manual/dir-add.info: FORCE
	$(MAKE) $(PARALLELMFLAGS) -C $(@D) $(@F)
FORCE:

rpm/%: subdir_distinfo
	$(MAKE) $(PARALLELMFLAGS) -C $(@D) subdirs='$(subdirs)' $(@F)

# This is a special goal for people making binary distributions.  Normally
# everybody uses the DES based crypt library but for the distribution we
# need the only-MD5 based one as well.
md5-crypt/libmd5crypt:
	$(MAKE) $(PARALLELMFLAGS) -C $(@D) $(@F)

=== catgets/Makefile ===
# Copyright (C) 1996 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If
# not, write to the Free Software Foundation, Inc.,
# 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

#
#	Makefile for catgets.
#
subdir	:= catgets

headers		= nl_types.h
distribute	= catgetsinfo.h config.h
routines	= catgets open_catalog
others		= gencat
install-bin	= gencat

gencat-modules	= xmalloc

# To find xmalloc.c
vpath %.c ../locale/programs


include ../Rules

$(objpfx)gencat: $(gencat-modules:%=$(objpfx)%.o)

CPPFLAGS := -DNLSPATH='"$(localedir)/%L/%N:$(localedir)/%L/LC_MESSAGES/%N:"' \
	    -DHAVE_CONFIG_H $(CPPFLAGS)

=== csu/Makefile ===
# Makefile for csu code for GNU C library.

# Copyright (C) 1995, 1996, 1997 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License
# as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# This directory contains the C startup code (that which calls main).  This
# consists of the startfile, built from start.c and installed as crt0.o
# (traditionally) or crt1.o (for ELF).  In ELF we also install crti.o and
# crtn.o, special "initializer" and "finalizer" files in used in the link
# to make the .init and .fini sections work right; both these files are
# built (in an arcane manner) from initfini.c.

subdir := csu

routines = init-first
csu-dummies = $(filter-out $(start-installed-name),crt1.o Mcrt1.o)
extra-objs = start.o gmon-start.o \
	     $(start-installed-name) g$(start-installed-name) \
	     $(csu-dummies)
omit-deps = $(patsubst %.o,%,$(start-installed-name) g$(start-installed-name) \
		             $(csu-dummies))
install-lib = $(start-installed-name) g$(start-installed-name) \
	      $(csu-dummies)
distribute = initfini.c gmon-start.c start.c defs.awk

all: # Make this the default target; it will be defined in Rules.

include ../Makeconfig

ifneq ($(elf),yes)

# When not using ELF, there is just one startfile, called crt0.o.
start-installed-name = crt0.o

else

# In the ELF universe, crt0.o is called crt1.o, and there are
# some additional bizarre files.
start-installed-name = crt1.o
have-initfini = yes

endif

ifeq ($(have-initfini),yes)

CPPFLAGS += -DHAVE_INITFINI

# These are the special initializer/finalizer files.  They are always the
# first and last file in the link.  crti.o ... crtn.o define the global
# "functions" _init and _fini to run the .init and .fini sections.
crtstuff = crti crtn

install-lib += $(crtstuff:=.o)
extra-objs += $(crtstuff:=.o)
generated += $(crtstuff:=.S) initfini.s align.h end.h
omit-deps += $(crtstuff)

# Special rules for the building of crti.o and crtn.o
$(objpfx)crt%.o: $(objpfx)crt%.S $(objpfx)defs.h
	$(CC) -c -fPIC -g0 -I$(..) -I$(common-objpfx) -DASSEMBLER $< -o $@

$(objpfx)initfini.s: initfini.c
	$(CC) $(CPPFLAGS) $(CFLAGS) -g0 -S -fPIC -finhibit-size-directive \
	      -fno-inline-functions $(no-exceptions) $< -o $@

$(objpfx)crti.S: $(objpfx)initfini.s
	sed -n -e '1,/@HEADER_ENDS/p' \
	       -e '/@_.*_PROLOG_BEGINS/,/@_.*_PROLOG_ENDS/p' \
	       -e '/@TRAILER_BEGINS/,$$p' $< > $@

$(objpfx)crtn.S: $(objpfx)initfini.s
	sed -n -e '1,/@HEADER_ENDS/p' \
	       -e '/@_.*_EPILOG_BEGINS/,/@_.*_EPILOG_ENDS/p' \
	       -e '/@TRAILER_BEGINS/,$$p' $< > $@

$(objpfx)defs.h: $(objpfx)initfini.s
	sed -n -e '/@TESTS_BEGIN/,/@TESTS_END/p' $< | \
		awk -f defs.awk > $@

endif

include ../Rules

ifndef start-installed-name-rule
# The startfile is installed under different names, so we just call our
# source file `start.c' and copy to the installed name after compiling.
$(objpfx)$(start-installed-name): $(objpfx)start.o
	-rm -f $@
	ln $< $@
endif

# The profiling startfile is made by linking together the normal
# startfile with gmon-start.o, which defines a constructor function
# to turn on profiling code at startup.
$(objpfx)g$(start-installed-name): $(objpfx)start.o $(objpfx)gmon-start.o
	$(CC) -nostdlib -nostartfiles -r -o $@ $^

# These extra files are sometimes expected by system standard linking
# procedures, but we have nothing for them to do.  So compile empty files.
$(addprefix $(objpfx),$(filter-out $(start-installed-name),$(csu-dummies))):
	cp /dev/null $(@:.o=.c)
	$(COMPILE.c) $(@:.o=.c) $(OUTPUT_OPTION)
	rm -f $(@:.o=.c)

=== ctype/Makefile ===
# Copyright (C) 1991, 1992, 1993, 1997 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

#
#	Sub-makefile for ctype portion of the library.
#
subdir	:= ctype

routines	:= ctype ctype-extn
aux		:= ctype-info

tests	:= test_ctype

include ../Rules

=== debian/Makefile ===
# This is a dummy Makefile to satisfy GNU libc's build mechanism.  It is
# only needed to name the files which have to be distributed.

subdir := debian

distribute := FAQ README changelog control control.in copyright do_locales \
	      rules shlibs shlibs.alpha shlibs.m68k substvars tzconfig	   \
	      libc/postinst libc/preinst				   \
	      libc-dev/preinst						   \
	      libc-doc/postinst libc-doc/prerm				   \
	      timezones/conffiles timezones/postinst timezones/postrm

include ../Rules

=== dirent/Makefile ===
# Copyright (C) 1991, 92, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

#
#	Sub-makefile for dirent portion of the library.
#
subdir		:= dirent

headers		:= dirent.h direntry.h
routines	:= opendir closedir readdir readdir_r rewinddir \
		   seekdir telldir scandir alphasort \
		   getdents dirfd
distribute := dirstream.h

tests	   := list tst-seekdir

include ../Rules

=== inet/Makefile ===
# Copyright (C) 1991, 92, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

#
#	Sub-makefile for inet portion of the library.
#
subdir	:= inet

headers	:= netinet/ether.h netinet/in.h netinet/if_ether.h \
	   netinet/tcp.h netinet/ip.h $(wildcard arpa/*.h protocols/*.h) \
	   aliases.h

distribute := netgroup.h

routines := ntohl ntohs htonl htons		\
	    inet_lnaof inet_mkadr	\
	    inet_netof inet_ntoa inet_net herrno \
	    gethstbyad gethstbyad_r gethstbynm gethstbynm2 gethstbynm2_r \
	    gethstbynm_r gethstent gethstent_r \
	    getnetbyad getnetbyad_r getnetbynm getnetent getnetent_r \
	    getnetbynm_r \
	    getproto getproto_r getprtent getprtent_r getprtname getprtname_r \
	    getsrvbynm getsrvbynm_r getsrvbypt getsrvbypt_r getservent \
	    getservent_r	\
	    getrpcent getrpcbyname getrpcbynumber \
	    getrpcent_r getrpcbyname_r getrpcbynumber_r \
	    ether_aton ether_aton_r ether_hton ether_line \
	    ether_ntoa ether_ntoa_r ether_ntoh \
	    rcmd rexec ruserpass \
	    getnetgrent_r getnetgrent \
	    getaliasent_r getaliasent getaliasname getaliasname_r

# No warnings about losing BSD code.
CFLAGS-rcmd.c = -w
CFLAGS-rexec.c = -w
CFLAGS-ruserpass.c = -w

include ../Rules

=== locale/Makefile ===
# Copyright (C) 1991, 1992, 1995, 1996, 1997 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

#
#	Makefile for locales.
#
subdir	:= locale

headers		= locale.h langinfo.h
distribute	= localeinfo.h categories.def iso-4217.def weight.h \
		  strlen-hash.h \
		  $(addprefix programs/, \
			      locale.c localedef.c \
			      $(localedef-modules:=.c) $(locale-modules:=.c) \
			      $(lib-modules:=.c) config.h simple-hash.h \
			      charmap-kw.gperf charmap-kw.h locfile-token.h \
			      locfile-kw.gperf locfile-kw.h linereader.h \
			      locales.h locfile.h stringtrans.h charset.h)
routines	= setlocale findlocale loadlocale localeconv nl_langinfo \
		  mb_cur_max codeset_name
categories	= ctype messages monetary numeric time collate
aux		= $(categories:%=lc-%) $(categories:%=C-%) SYS_libc C_name
others		= localedef locale
install-bin	= localedef locale
extra-objs	= $(localedef-modules:=.o) $(locale-modules:=.o) \
		  $(lib-modules:=.o)

extra-libs	= libBrokenLocale
extra-libs-others = $(extra-libs)

libBrokenLocale-routines = broken_cur_max

subdir-dirs	= programs
vpath %.c programs
vpath %.h programs
vpath %.gperf programs

localedef-modules	:= $(categories:%=ld-%) charmap charset linereader \
			   locfile stringtrans
locale-modules		:= locale-spec
lib-modules		:= simple-hash xmalloc xstrdup


GPERF = gperf
GPERFFLAGS = -acCgopt -k1,2,5,$$

include ../Rules

programs/%-kw.h: programs/%-kw.gperf
	$(GPERF) $(GPERFFLAGS) -N $(@F:-kw.h=_hash) $< > $@.new
	mv -f $@.new $@

$(objpfx)localedef: $(localedef-modules:%=$(objpfx)%.o)
$(objpfx)locale: $(locale-modules:%=$(objpfx)%.o)
$(objpfx)localedef $(objpfx)locale: $(lib-modules:%=$(objpfx)%.o)

localepath = "$(localedir):$(i18ndir)"

CPPFLAGS := -DLOCALE_PATH='$(localepath)' \
	    -DLOCALEDIR='"$(localedir)"' \
	    -DLOCALE_ALIAS_PATH='"$(localedir):$(i18ndir)"' \
	    -DCHARMAP_PATH='"$(i18ndir)/charmaps"' \
	    -DLOCSRCDIR='"$(i18ndir)/locales"' -DHAVE_CONFIG_H \
	    -Iprograms $(CPPFLAGS)

CFLAGS-charmap.c = -Wno-write-strings -Wno-char-subscripts
CFLAGS-locfile.c = -Wno-write-strings -Wno-char-subscripts

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(objpfx)libBrokenLocale.so: $(common-objpfx)libc.so

=== login/Makefile ===
# Copyright (C) 1996, 1997 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

#
#	Sub-makefile for login portion of the library.
#

subdir	:= login

headers	:= utmp.h utmpbits.h lastlog.h pty.h

routines := getutent getutent_r getutid getutline getutid_r getutline_r \
	    utmp_file updwtmp utmpname

distribute := utmp-private.h

# Build the -lutil library with these extra functions.
extra-libs      := libutil
extra-libs-others := $(extra-libs)

libutil-routines:= login login_tty logout logwtmp pty

include ../Rules

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(objpfx)libutil.so: $(common-objpfx)libc.so

=== manual/Makefile ===
# Copyright (C) 1992, 93, 94, 95, 96, 97 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License
# as published by the Free Software Foundation; either version 2 of
# the License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# Makefile for the GNU C Library manual.

subdir := manual
export subdir := $(subdir)

# We need GNU awk for the xtract-typefun script.
GAWK = gawk
# Allow override
INSTALL_INFO = install-info

.PHONY: all dvi info
all: dvi info
dvi: libc.dvi
info: libc.info dir-add.info

# Get glibc's configuration info.
ifneq (,$(wildcard ../Makeconfig))
include ../Makeconfig
endif

# Set chapters and chapters-incl.
-include chapters
chapters: libc.texinfo
	$(find-includes)
ifdef chapters
-include chapters-incl
chapters-incl: $(chapters)
	$(find-includes)
chapters-incl := $(filter-out summary.texi,$(chapters-incl))
endif

define find-includes
(echo '$(@F) :=' \\	;\
 awk '$$1 == "@include" { print $$2 " \\" }' $^) > $@.new
mv -f $@.new $@
endef

libc.dvi libc.info: $(chapters) summary.texi $(chapters-incl)
libc.dvi: texinfo.tex

# Generate the summary from the Texinfo source files for each chapter.
summary.texi: stamp-summary ;
stamp-summary: summary.awk $(chapters) $(chapters-incl)
	awk -f $^ \
	| sort -df +1 -2 | tr '\014' '\012' > summary-tmp
	./move-if-change summary-tmp summary.texi
# touch is broken on our machines.  Sigh.
	date > $@

# Generate a file which can be added to the `dir' content to provide direct
# access to the documentation of the function, variables, and other
# definitions.
dir-add.texi: xtract-typefun.awk $(chapters) $(chapters-incl)
	(echo "@dircategory GNU C library functions";			\
	 echo "@direntry";						\
	 $(GAWK) -f $^ | sort;						\
	 echo "@end direntry";) > $@.new
	mv -f $@.new $@

# Generate Texinfo files from the C source for the example programs.
%.c.texi: examples/%.c
	sed -e 's,[{}],@&,g'				\
	    -e 's,/\*\(@.*\)\*/,\1,g'			\
	    -e 's,/\*  *,/* @r{,g' -e 's,  *\*/,} */,'	\
	    -e 's/\(@[a-z][a-z]*\)@{\([^}]*\)@}/\1{\2}/g'\
	    $< | expand > $@.new
	mv -f $@.new $@


minimal-dist = summary.awk move-if-change libc.texinfo $(chapters)	\
	       $(patsubst %.c.texi,examples/%.c,			\
			  $(filter-out summary.texi,$(chapters-incl)))
doc-only-dist = Makefile COPYING.LIB mkinstalldirs
distribute = $(minimal-dist)	       					\
	     $(patsubst examples/%.c,%.c.texi,$(filter examples/%.c,	\
			$(minimal-dist)))				\
	     libc.info* libc.?? libc.??s texinfo.tex summary.texi	\
	     stamp-summary chapters chapters-incl			\
	     xtract-typefun.awk dir-add.texi dir-add.info dir
export distribute := $(distribute)

tar-it = tar chovf $@ $^

manual.tar: $(doc-only-dist) $(minimal-dist) ; $(tar-it)
mandist.tar: $(doc-only-dist) $(distribute) ; $(tar-it)

edition := $(shell sed -n 's/^@set EDITION \([0-9][0-9.]*\)[^0-9.]*.*$$/\1/p' \
		       libc.texinfo)

glibc-doc-$(edition).tar: $(doc-only-dist) $(distribute)
	@rm -f glibc-doc-$(edition)
	ln -s . glibc-doc-$(edition)
	tar chovf $@ $(addprefix glibc-doc-$(edition)/,$^)
	rm -f glibc-doc-$(edition)

%.Z: %
	compress -c $< > $@.new
	mv -f $@.new $@
%.gz: %
	gzip -9 -c $< > $@.new
	mv -f $@.new $@
%.uu: %
	uuencode $< < $< > $@.new
	mv -f $@.new $@

.PHONY: mostlyclean distclean realclean clean
mostlyclean:
	-rm -f libc.dvi libc.info* dir-add.info
clean: mostlyclean
distclean: clean
indices = cp fn pg tp vr ky
realclean: distclean
	-rm -f chapters chapters-incl summary.texi stamp-summary *.c.texi
	-rm -f $(foreach index,$(indices),libc.$(index) libc.$(index)s)
	-rm -f libc.log libc.aux libc.toc dir-add.texi

.PHONY: install subdir_install installdirs install-data
install-data subdir_install: install
install: $(inst_infodir)/libc.info dir-add.info
	@if $(SHELL) -c '$(INSTALL_INFO) --version' >/dev/null 2>&1; then \
	  test -f $(inst_infodir)/dir || cp dir $(inst_infodir);\
	 $(INSTALL_INFO) --info-dir=$(inst_infodir) $(inst_infodir)/libc.info;\
	 $(INSTALL_INFO) --info-dir=$(inst_infodir) dir-add.info;\
	else : ; fi
# Catchall implicit rule for other installation targets from the parent.
install-%: ;

$(inst_infodir)/libc.info: libc.info installdirs
	for file in $<*; do \
	  name=`basename $$file`; \
	  $(INSTALL_DATA) $$file \
	    `echo $@ | sed "s,$<\$$,$$name,"`; \
	done

installdirs: $(firstword $(wildcard mkinstalldirs ../mkinstalldirs))
	$(dir $<)$(notdir $<) $(inst_infodir)

.PHONY: dist
dist: # glibc-doc-$(edition).tar.gz

ifneq (,$(wildcard ../Make-dist))
dist: ../Make-dist
	$(MAKE) -f $< $(Make-dist-args)
endif

ifndef ETAGS
ETAGS = etags -T
endif
TAGS: $(minimal-dist)
	$(ETAGS) -o $@ $^

# The parent makefile sometimes invokes us with targets `subdir_REAL-TARGET'.
subdir_%: % ;
# For targets we don't define, do nothing.
subdir_%: ;

# These are targets that each glibc subdirectory is expected to understand.
# ../Rules defines them for code subdirectories; for us, they are no-ops.
# None of these should be `subdir_TARGET'; those targets are transformed
# by the implicit rule above into `TARGET' deps.
glibc-targets	:= lib objects objs others tests lint.out \
		   echo-headers echo-distinfo stubs
.PHONY: $(glibc-targets)
$(glibc-targets):

# Create stamp files if they don't exist, so the parent makefile's rules for
# updating the library archives are happy with us, and never think we have
# changed the library.
lib: $(foreach o,$(object-suffixes),$(objpfx)stamp$o-$(subdir))
stubs: $(common-objpfx)stub-manual
$(common-objpfx)stub-manual ../po/manual.pot $(objpfx)stamp%-$(subdir):
	$(make-target-directory)
	cp /dev/null $@


# Make the target directory if it doesn't exist, using the `mkinstalldirs'
# script that does `mkdir -p' even if `mkdir' doesn't support that flag.
define make-target-directory
$(addprefix $(..)./mkinstalldirs ,\
	    $(filter-out $(wildcard $(@D:%/=%)),$(@D:%/=%)))
endef

# The top-level glibc Makefile expects subdir_install to update the stubs file.
subdir_install: stubs

# Get rid of these variables if they came from the parent.
routines =
aux =
sources =
objects =
headers =

=== math/Makefile ===
# Copyright (C) 1996, 1997 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

# Makefile for the math library.

subdir		:= math

# Installed header files.
headers		:= math.h mathcalls.h __math.h huge_val.h nan.h fpu_control.h

# Internal header files.
distribute	:= math_private.h machine/asm.h machine/endian.h

# FPU support code.
aux		:= fpu_control setfpucw

# Build the -lm library.

extra-libs	:= libm
extra-libs-others = $(extra-libs)

libm-support = k_standard s_lib_version s_matherr s_signgam
libm-calls = e_acos e_acosh e_asin e_atan2 e_atanh e_cosh e_exp e_fmod	\
	     e_hypot e_j0 e_j1 e_jn e_lgamma_r e_log e_log10 e_pow	\
	     e_rem_pio2 e_remainder e_scalb e_sinh e_sqrt k_cos		\
	     k_rem_pio2 k_sin k_tan s_asinh s_atan s_cbrt		\
	     s_ceil s_copysign s_cos s_erf s_expm1 s_fabs s_finite	\
	     s_floor s_frexp s_ilogb s_ldexp s_log1p s_logb 		\
	     s_modf s_nextafter s_rint s_scalbn s_significand		\
	     s_sin s_tan s_tanh w_acos w_acosh w_asin			\
	     w_atan2 w_atanh w_cabs w_cosh w_drem w_exp w_fmod w_gamma	\
	     w_gamma_r w_hypot w_j0 w_j1 w_jn w_lgamma w_lgamma_r	\
	     w_log w_log10 w_pow w_remainder w_scalb w_sinh w_sqrt
libm-routines = $(libm-support) $(libm-calls) \
		$(patsubst %_rf,%f_r,$(libm-calls:=f))	\
		$(long-m-$(long-double-fcts))
long-m-routines = $(patsubst %_rl,%l_r,$(libm-calls:=l))
long-m-yes = $(long-m-routines)
distribute += $(long-m-yes:=.c)

# These functions are in libc instead of libm because __printf_fp
# calls them, so any program using printf will need them linked in,
# and we don't want to have to link every program with -lm.
calls = s_isinf s_isnan s_finite s_copysign s_modf s_scalbn s_frexp s_ldexp
routines = $(calls) $(calls:=f) $(long-c-$(long-double-fcts))
long-c-yes = $(calls:=l)
distribute += $(long-c-yes:=.c)


# The -lieee module sets the _LIB_VERSION_ switch to IEEE mode
# for error handling in the -lm functions.
install-lib += libieee.a
non-lib.a += libieee.a
extra-objs += libieee.a ieee-math.o
distribute += ieee-math.c

include ../Rules


# This file defines the default _LIB_VERSION variable that controls
# the error return conventions for the math functions.
CPPFLAGS-s_lib_version.c := -D_POSIX_MODE

# We don't want the fdlibm code to use the inline math functions,
# only the fdlibm code.
CPPFLAGS += -D__NO_MATH_INLINES

ifneq ($(long-double-fcts),yes)
# The `double' and `long double' types are the same on this machine.
# We won't compile the `long double' code at all.  Tell the `double' code
# to define aliases for the `FUNCl' names.  To avoid type conflicts in
# defining those aliases, tell <math.h> to declare the `FUNCl' names with
# `double' instead of `long double'.
CPPFLAGS += -DNO_LONG_DOUBLE -D_Mlong_double_=double
endif

# The fdlibm code generates a lot of these warnings but is otherwise clean.
override CFLAGS += -Wno-uninitialized -Wno-write-strings

# The -lieee library is actually an object file.
# The module just defines the _LIB_VERSION_ variable.
# It's not a library to make sure it is linked in instead of s_lib_version.o.
$(objpfx)libieee.a: $(objpfx)ieee-math.o
	rm -f $@
	ln $< $@

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(objpfx)libm.so: $(common-objpfx)libc.so

=== nis/Makefile ===
# Copyright (C) 1996, 1997 Free Software Foundation, Inc.
# This file is part of the GNU C Library.

# The GNU C Library is free software; you can redistribute it and/or
# modify it under the terms of the GNU Library General Public License as
# published by the Free Software Foundation; either version 2 of the
# License, or (at your option) any later version.

# The GNU C Library is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
# Library General Public License for more details.

# You should have received a copy of the GNU Library General Public
# License along with the GNU C Library; see the file COPYING.LIB.  If not,
# write to the Free Software Foundation, Inc., 59 Temple Place - Suite 330,
# Boston, MA 02111-1307, USA.

#
#	Makefile for NIS part.
#
subdir	:= nis

headers			:= $(wildcard rpcsvc/*.[hx])
distribute		:= nss-nis.h

# These are the databases available for the nis (and perhaps later nisplus)
# service.  This must be a superset of the services in nss.
databases		= proto service hosts network grp pwd rpc ethers \
			  spwd netgrp alias

# Specify rules for the nss_* modules.  Later we may have nisplus as well.
services		:= nis compat

extra-libs		= libnsl $(services:%=libnss_%)
# These libraries will be built in the `others' pass rather than
# the `lib' pass, because they depend on libc.so being built already.
extra-libs-others	= $(extra-libs)

# The sources are found in the appropriate subdir.
subdir-dirs = $(services:%=nss_%)
vpath %.c $(subdir-dirs)

libnsl-routines = yp_xdr ypclnt ypupdate_xdr

libnss_compat-routines	:= $(addprefix compat-,grp pwd spwd)
libnss_compat-inhibit-o	= $(filter-out .so,$(object-suffixes))

libnss_nis-routines	:= $(addprefix nis-,$(databases))
libnss_nis-inhibit-o	= $(filter-out .so,$(object-suffixes))


# Sun's header files are not too clean.
CFLAGS-compat-pwd.c = -Wno-strict-prototypes
CFLAGS-compat-spwd.c = -Wno-strict-prototypes
CFLAGS-compat-grp.c = -Wno-strict-prototypes
CFLAGS-nis-alias.c = -Wno-strict-prototypes
CFLAGS-nis-ethers.c = -Wno-strict-prototypes
CFLAGS-nis-grp.c = -Wno-strict-prototypes
CFLAGS-nis-hosts.c = -Wno-strict-prototypes
CFLAGS-nis-netgrp.c = -Wno-strict-prototypes
CFLAGS-nis-network.c = -Wno-strict-prototypes
CFLAGS-nis-proto.c = -Wno-strict-prototypes
CFLAGS-nis-publickey.c = -Wno-strict-prototypes
CFLAGS-nis-pwd.c = -Wno-strict-prototypes
CFLAGS-nis-rpc.c = -Wno-strict-prototypes
CFLAGS-nis-service.c = -Wno-strict-prototypes
CFLAGS-nis-spwd.c = -Wno-strict-prototypes
CFLAGS-ypclnt.c = -Wno-strict-prototypes -Wno-write-strings -Irpcsvc
CFLAGS-yp_xdr.c = -Wno-strict-prototypes -Irpcsvc
CFLAGS-ypupdate_xdr.c = -Wno-strict-prototypes -Irpcsvc

include ../Rules


$(objpfx)libnss_compat.so: $(objpfx)libnsl.so$(libnsl.so-version) \
			   $(common-objpfx)nss/libnss_files.so
$(objpfx)libnss_nis.so: $(objpfx)libnsl.so$(libnsl.so-version) \
			$(common-objpfx)nss/libnss_files.so

# Depend on libc.so so a DT_NEEDED is generated in the shared objects.
# This ensures they will load libc.so for needed symbols if loaded by
# a statically-linked program that hasn't already loaded it.
$(services:%=$(objpfx)libnss_%.so) $(objpfx)libnsl.so: $(common-objpfx)libc.so


ifeq ($(build-shared),yes)
$(others:%=$(objpfx)%): $(objpfx)libnsl.so$(libnsl.so-version)
else
$(others:%=$(objpfx)%): $(objpfx)libnsl.a
endif

=== debian/changelog ===
glibc (2.0.6-1) unstable; urgency=low

  * New upstream version (2.0.6).

 -- David Engel <david@sw.ods.com>  Sun, 28 Dec 1997 15:09:41 -0600

glibc (2.0.6-0.6) unstable; urgency=low

  * New upstream version (2.0.6pre6).

 -- David Engel <david@sw.ods.com>  Sat, 27 Dec 1997 23:34:43 -0600

glibc (2.0.6-0.5) unstable; urgency=low

  * New upstream version (2.0.6pre5).
  * Updated Debian README and FAQ for inclusion in upstream source.
  * Changed libc6 to conflict with old libc5 packages.
  * Changed libc6 to conflict with existing libpthread0 packages.
  * Fixed libc6-dev to create /usr/include symlinks correctly.
  * Changed libc6-dev to depend on either kernel-headers or kernel-source.
  * Fixed libc6-doc to not include erroneous dir.gz.
  
 -- David Engel <david@sw.ods.com>  Mon, 22 Dec 1997 01:14:22 -0600

glibc (2.0.6-0.4) unstable; urgency=low

  * New upstream version (2.0.6-pre4).
  * Use and depend on kernel-headers-2.0.32 package for the kernel
    header files.
  * Remove obsolete patches from debian directory.

 -- David Engel <david@sw.ods.com>  Fri, 12 Dec 1997 00:20:57 -0600

glibc (2.0.6-0.3) unstable; urgency=low

  * New upstream version (2.0.6-pre3).

 -- David Engel <david@sw.ods.com>  Tue,  9 Dec 1997 21:47:20 -0600

glibc (2.0.6-0.2) unstable; urgency=low

  * New upstream version (2.0.6-pre2).
  * New kernel headers (2.0.32).
  * Fixed m68k build and dependency problems.
  * Added Conflicts: libpthread0 (=0.6-1).
  * Added INSTALL to /usr/doc at request of upstream maintainer.

 -- David Engel <david@sw.ods.com>  Wed, 19 Nov 1997 20:23:02 -0600

glibc (2.0.6-0.1) unstable; urgency=low

  * New upstream version (2.0.6-pre1).
  * New kernel headers (2.0.32-pre4).

 -- David Engel <david@sw.ods.com>  Fri, 14 Nov 1997 19:43:06 -0600

glibc (2.0.5c-0.1) unstable; urgency=low

  * New upstream version. (10417,12304)
  * Fix security hole in tzconfig. (11609)
  * Patch linuxthreads for libstdc++

 -- Guy Maor <maor@ece.utexas.edu>  Fri,  3 Oct 1997 14:08:30 -0500

glibc (2.0.4-1) unstable; urgency=low

  * new Maintainer
  * new upstream version
  * included asm-m68k fixes (James Troup <J.J.Troup@comp.brad.ac.uk>)

 -- Helmut Geyer <Helmut.Geyer@iwr.uni-heidelberg.de>  Fri, 23 May 1997 20:00:00 +0200

glibc (2.0.3-4) unstable; urgency=low

  * Changed tzconfig to allow Canadian timezones to be selected by
    name.
  * Changed libc6-dev to legally replace parts of the man-db, gettext
    and ppp packages (Bug#9815 abd Bug#9825).

 -- David Engel <david@sw.ods.com>  Thu, 15 May 1997 12:35:43 -0500

glibc (2.0.3-3) unstable; urgency=low

  * Integrated Mike Dorman's patches for the alpha (Bug#9208,
    Bug#9212 and Bug#9219).

 -- David Engel <david@sw.ods.com>  Mon, 5 May 1997 11:32:14 -0500

glibc (2.0.3-2) unstable; urgency=low

  * Fixed a problem with the .orig.tar.gz file.
  * Really moved from experimental to unstable.
  * Added initial, integrated support for alpha architecture.

 -- David Engel <david@sw.ods.com>  Fri, 25 Apr 1997 15:15:37 -0500

glibc (2.0.3-1) experimental; urgency=low

  * Updated to new upstream version.
  * Moved from experimental section to unstable.
  * Included man pages for linuxthreads.

 -- David Engel <david@sw.ods.com>  Tue, 22 Apr 1997 08:56:37 -0500

glibc (2.0.2-2) experimental; urgency=low

  * Added a shlibs entry for /lib/ld-linux.so.2.
  * Added symlinks to /usr/doc/libc6 for -dev, -dbg and -doc
    packages.

 -- David Engel <david@sw.ods.com>  Fri, 4 Apr 1997 21:58:44 -0600

glibc (2.0.2-1) experimental; urgency=low

  * Updated to new upstream version.

 -- David Engel <david@sw.ods.com>  Sat, 22 Mar 1997 11:53:16 -0600

glibc (2.0.1-2) experimental; urgency=low

  * Changed to work with ldso-1.9.x.
  * Changed to build with local kernel headers.
  * Changed is_IS locale to match that from wg15-locale.
  * Added compiled versions of locales.
  * Added documentation from add-on packages.
  * Fixed install problems with timezones.
  * Moved libdb headers from /usr/include/db to /usr/include.

 -- David Engel <david@sw.ods.com>  Thu, 27 Feb 1997 19:57:25 -0600

glibc (2.0.1-1) experimental; urgency=low

  * Initial packaging.

 -- David Engel <david@debian.org>  Thu, 20 Feb 1997 21:15:52 -0600

Local variables:
mode: debian-changelog
End:

=== debian/control ===
Source: glibc
Section: libs
Priority: required
Maintainer: David Engel <david@debian.org>
Standards-Version: 2.1.2.2

Package: libc6
Architecture: any
Section: base
Priority: required
Pre-Depends: ${i386:libc6}${m68k:libc6}
Conflicts: libc5 (<<5.4.33-7), libpthread0 (<<0.7-10)
Description: The GNU C library version 2 (run-time files).
 Includes shared libraries needed to run programs.

Package: libc6-dev
Architecture: any
Section: devel
Priority: standard
Depends: libc6 (=${Source-Version}), kernel-headers-${kversion} (>=${kversion}-${krevision}) | kernel-source-${kversion} (>=${kversion}-${krevision}), gcc (>=2.7.2.3-1)
Conflicts: libc-dev, libdl1-dev, libdb1-dev, libgdbm1-dev, libpthread0-dev
Replaces: ldso (<<1.9.0-0), man-db (<=2.3.10-37), gettext (<=0.10.26-1), ppp (<=2.2.0f-24)
Provides: libc-dev
Description: The GNU C library version 2 (development files).
 Includes libc headers, kernel headers and static libraries.

Package: libc6-dbg
Architecture: any
Section: devel
Priority: optional
Depends: libc6-dev (=${Source-Version})
Conflicts: libc-dbg
Provides: libc-dbg
Description: The GNU C library version 2 (debugging/profiling files).
 Includes static libraries compiled with debugging and profiling info.

Package: libc6-pic
Architecture: any
Section: devel
Priority: optional
Depends: libc6-dev (=${Source-Version})
Conflicts: libc-pic
Provides: libc-pic
Description: The GNU C library version 2 (PIC library)
 Contains PIC library for generating reduced glibc for installation disks.

Package: libc6-doc
Architecture: all
Section: doc
Priority: optional
Depends: libc6 (=${Source-Version})
Conflicts: libc-doc, glibcdoc
Replaces: glibcdoc
Provides: libc-doc
Description: The GNU C library version 2 (documentation files)
 Contains info file and other Documentation.

Package: locales
Architecture: any
Section: admin
Priority: standard
Depends: libc6
Conflicts: localebin, wg15-locale
Replaces: localebin, wg15-locale
Description: Locale data files and utilities.
 Contains utilities and machine-readable files used by the C library
 to internationalization.

Package: timezones
Architecture: any
Section: base
Priority: required
Depends: libc6
Conflicts: timezone
Replaces: timezone
Description: Time zone data files and utilities.
 Contains utilities and machine-readable files used by the C library
 to time zones, local time.

=== debian/rules ===
#!/usr/bin/make -f
# Sample debian/rules file - for GNU Hello (1.3).
# Copyright 1994,1995 by Ian Jackson.
# I hereby give you perpetual unlimited permission to copy,
# modify and relicense this file, provided that you do not remove
# my name from the file itself.  (I assert my moral right of
# paternity under the Copyright, Designs and Patents Act 1988.)
# This file may have to be extensively modified
#
# Modified for glibc by David Engel <david@debian.org>

arch = $(shell dpkg --print-architecture)

ifeq ($(arch),alpha)
p = libc6.1
LOADER = ld-linux.so.2
KVERSION = 2.0.32
KREVISION = 2
else
ifeq ($(arch),m68k)
p = libc6
LOADER = ld.so.1
KVERSION = 2.0.32
KREVISION = 2
else
p = libc6
LOADER = ld-linux.so.2
KVERSION = 2.0.32
KREVISION = 2
endif
endif

build:
ifeq ($(MAKE_VERSION), 3.76)
	echo "Make 3.76 is broken!  Use make 3.76.1"
	false
endif
	-mkdir builddir
	ln -sf /usr/src/linux-${KVERSION}/include/linux linux
	ln -sf /usr/src/linux-${KVERSION}/include/asm asm
	cd builddir && ../configure --prefix=/usr \
	  --sysconfdir=/etc --localstatedir=/var \
	  --enable-add-ons=crypt,linuxthreads,localedata
	cd builddir && $(MAKE)
	cd linuxthreads/man && make all
	touch build

clean:
	-find . -name '*~' | xargs rm -f
	-rm -rf build builddir linux asm pre-binary
	-cd linuxthreads/man && make clean
	-rm -rf debian/hold debian/tmp debian/files*

binary:		build binary-indep binary-arch

binary-indep:	binary-doc

binary-arch:	binary-run binary-dev binary-dbg binary-pic \
		binary-locales binary-timezones

pre-binary: build
	# copy most everything into debian/hold
	-rm -rf debian/hold
	install -d debian/hold
	cd builddir && make install_root=`pwd`/../debian/hold \
	  INSTALL_INFO=true install
	install -d debian/hold/usr/man/man3
	cd linuxthreads/man && \
	  make MANDIR='../../debian/hold/usr/man/man3' install
	rm -f debian/hold/usr/lib/libg.a
	sed -e 's/LIBC/$(p)/g' < debian/control.in > debian/control
	echo "$(arch):libc6=ldso (>= 1.8.10-1)" > debian/substvars
	echo "kversion=$(KVERSION)" >> debian/substvars
	echo "krevision=$(KREVISION)" >> debian/substvars
	touch pre-binary

binary-run:	checkroot pre-binary
	# build the libc6 binary
	-rm -rf debian/tmp
	install -d debian/tmp/usr/bin \
                   debian/tmp/lib \
		   debian/tmp/usr/doc/$(p) \
		   debian/tmp/DEBIAN
ifeq ($(arch),alpha)
	cp -a debian/hold/usr/bin/ldd debian/tmp/usr/bin
endif
	cp -a debian/hold/lib/{ld,lib}*-2*.so debian/tmp/lib
	cp -a debian/hold/lib/lib*-0*.so debian/tmp/lib
	#strip -g -K _dl_debug_state debian/tmp/lib/ld*.so
	strip debian/tmp/lib/lib*.so
	cp -a debian/hold/lib/{ld,lib}*.so.* debian/tmp/lib
	for f in ChangeLog BUGS FAQ INSTALL NEWS NOTES PROJECTS README ; do \
	  cp -a $$f debian/tmp/usr/doc/$(p)/$$f ; \
	done
	cd crypt && for f in README ; do \
	  cp -a $$f ../debian/tmp/usr/doc/$(p)/$$f.crypt ; \
	done
	cd linuxthreads && for f in README* Changes ChangeLog ; do \
	  cp -a $$f ../debian/tmp/usr/doc/$(p)/$$f.linuxthreads ; \
	done
	cd localedata && for f in README ChangeLog ; do \
	  cp -a $$f ../debian/tmp/usr/doc/$(p)/$$f.localedata ; \
	done
	cp debian/changelog debian/tmp/usr/doc/$(p)/changelog.Debian
	cp debian/FAQ debian/tmp/usr/doc/$(p)/FAQ.Debian
	gzip -f9 debian/tmp/usr/doc/$(p)/*
	cp debian/copyright debian/tmp/usr/doc/$(p)
	cp debian/libc/* debian/tmp/DEBIAN
	if [ -f debian/shlibs.$(arch) ] ; then \
	  cp debian/shlibs.$(arch) debian/tmp/DEBIAN/shlibs ; \
	else \
	  cp debian/shlibs debian/tmp/DEBIAN ; \
	fi
	chmod +x debian/tmp/DEBIAN/p*
	dpkg-gencontrol -p$(p)
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary-dev:	checkroot pre-binary
	# build the $(p)-dev binary
	-rm -rf debian/tmp
	install -d debian/tmp/usr/bin \
		   debian/tmp/usr/lib \
		   debian/tmp/usr/include \
		   debian/tmp/usr/doc \
		   debian/tmp/DEBIAN
	cp -a debian/hold/usr/bin/{gencat,getconf,makedb} debian/tmp/usr/bin
	strip debian/tmp/usr/bin/*
	cp -a debian/hold/usr/bin/glibcbug debian/tmp/usr/bin
	cp -a debian/hold/usr/lib/*.{o,a} debian/tmp/usr/lib
	rm -f debian/tmp/usr/lib/lib*_p.a
	strip -g debian/tmp/usr/lib/*.{o,a}
	cp -a debian/hold/usr/lib/lib*.so debian/tmp/usr/lib
	cp -a debian/hold/usr/include/* debian/tmp/usr/include
	ln -sf /usr/src/linux-${KVERSION}/include/linux \
	  debian/tmp/usr/include/linux
	ln -sf /usr/src/linux-${KVERSION}/include/asm \
	  debian/tmp/usr/include/asm
	ln -sf $(p) debian/tmp/usr/doc/$(p)-dev
	cp debian/libc-dev/* debian/tmp/DEBIAN
	chmod +x debian/tmp/DEBIAN/p*
	dpkg-gencontrol -p$(p)-dev
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary-dbg:	checkroot pre-binary
	# build the $(p)-dbg binary
	-rm -rf debian/tmp
	install -d debian/tmp/usr/lib \
		   debian/tmp/usr/doc \
		   debian/tmp/DEBIAN
	for f in `find debian/hold/usr/lib -name '*.a' ! -name '*_p.a'` ; do \
	  cp $$f debian/tmp/usr/lib/`basename $$f .a`_g.a ; \
	done
	cp -a debian/hold/usr/lib/*_p.a debian/tmp/usr/lib
	ln -sf $(p) debian/tmp/usr/doc/$(p)-dbg
	#cp debian/libc-dbg/* debian/tmp/DEBIAN
	#chmod +x debian/tmp/DEBIAN/p*
	dpkg-gencontrol -p$(p)-dbg
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary-pic:	checkroot pre-binary
	# build the $(p)-pic binary
	-rm -rf debian/tmp
	install -d debian/tmp/usr/lib \
		   debian/tmp/usr/doc \
		   debian/tmp/DEBIAN
	cp builddir/libc_pic.a debian/tmp/usr/lib
	ln -sf $(p) debian/tmp/usr/doc/$(p)-pic
	dpkg-gencontrol -p$(p)-pic
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary-doc:	checkroot pre-binary
	# build the $(p)-doc binary
	-rm -rf debian/tmp
	install -d debian/tmp/usr/info \
		   debian/tmp/usr/man \
		   debian/tmp/usr/doc \
		   debian/tmp/DEBIAN
	cp -a debian/hold/usr/info/* debian/tmp/usr/info
	rm -f debian/tmp/usr/info/dir
	gzip -f9 debian/tmp/usr/info/*
	cp -a debian/hold/usr/man/* debian/tmp/usr/man
	gzip -f9 debian/tmp/usr/man/*/*
	ln -sf $(p) debian/tmp/usr/doc/$(p)-doc
	cp debian/libc-doc/* debian/tmp/DEBIAN
	chmod +x debian/tmp/DEBIAN/p*
	dpkg-gencontrol -p$(p)-doc
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary-locales:	checkroot pre-binary
	# build the locales binary
	-rm -rf debian/tmp
	install -d debian/tmp/usr/bin \
		   debian/tmp/usr/share \
		   debian/tmp/usr/doc \
		   debian/tmp/DEBIAN
	cp -a debian/hold/usr/bin/{locale,localedef} debian/tmp/usr/bin
	strip debian/tmp/usr/bin/*
	cp -a debian/hold/usr/share/{i18n,locale} debian/tmp/usr/share
	bash debian/do_locales $(LOADER)
	ln -s $(p) debian/tmp/usr/doc/locales
	#cp debian/locales/* debian/tmp/DEBIAN
	#chmod +x debian/tmp/DEBIAN/p*
	dpkg-gencontrol -plocales
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

binary-timezones: checkroot pre-binary
	# build the timezones binary
	-rm -rf debian/tmp
	install -d debian/tmp/etc \
		   debian/tmp/usr/bin \
		   debian/tmp/usr/sbin \
		   debian/tmp/usr/share \
		   debian/tmp/usr/doc \
		   debian/tmp/DEBIAN
	echo Factory > debian/tmp/etc/timezone
	cp -a debian/hold/usr/bin/tzselect debian/tmp/usr/bin
	cp -a debian/hold/usr/sbin/{zdump,zic} debian/tmp/usr/sbin
	strip debian/tmp/usr/sbin/*
	cp -a debian/tzconfig debian/tmp/usr/sbin
	chmod +x debian/tmp/usr/sbin/tzconfig
	cp -a debian/hold/usr/share/zoneinfo debian/tmp/usr/share
	cp debian/timezones/* debian/tmp/DEBIAN
	chmod +x debian/tmp/DEBIAN/p*
	ln -s $(p) debian/tmp/usr/doc/timezones
	dpkg-gencontrol -ptimezones
	chmod -R g-w debian/tmp
	chown -R root.root debian/tmp
	dpkg --build debian/tmp ..

checkroot:
	$(checkdir)
	test root = "`whoami`"

.PHONY: binary binary-arch binary-indep clean checkroot

# Local Variables:
# mode: makefile
# end:
